# TODO:
# - package vendored modules
# - package fzf-tmux

%define		fzfrev		 e3e76fa
%define		fzfvimrev	 8fa9cf0

Summary:	A command-line fuzzy finder written in Go
Name:		fzf
Version:	0.24.4
Release:	1
License:	MIT
Group:		Applications/Shells
#Source0Download: https://github.com/junegunn/fzf/releases
Source0:	https://github.com/junegunn/fzf/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	e627828780d41ded82cb9209642ce985
# cd fzf-%{version}
# go mod vendor
# cd ..
# tar cJf fzf-vendor-%{version}.tar.xz fzf-%{version}/vendor
Source1:	%{name}-vendor-%{version}.tar.xz
# Source1-md5:	64f38dfc6f0cd4fc0008c45096223116
Source2:	https://github.com/junegunn/fzf.vim/archive/%{fzfvimrev}/fzf.vim-%{fzfvimrev}.tar.gz
# Source2-md5:	4d299b3212e34c57f966ec8f7562525d
URL:		https://github.com/junegunn/fzf
BuildRequires:	golang >= 1.13
BuildRequires:	sed >= 4.0
ExclusiveArch:	%{x8664} armv5l armv6l armv7l armv8l aarch64 ppc64le
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
fzf is a general-purpose command-line fuzzy finder.

It's an interactive Unix filter for command-line that can be used with
any list; files, command history, processes, hostnames, bookmarks, git
commits, etc.

%package -n bash-completion-fzf
Summary:	bash-completion for fzf
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	bash-completion >= 2.0
%if "%{_rpmversion}" >= "4.6"
BuildArch:	noarch
%endif

%description -n bash-completion-fzf
bash-completion for fzf.

%package -n zsh-completion-fzf
Summary:	zsh-completion for fzf
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	zsh
%if "%{_rpmversion}" >= "4.6"
BuildArch:	noarch
%endif

%description -n zsh-completion-fzf
zsh-completion for fzf.

%package -n vim-plugin-fzf
Summary:	fzf integration for Vim
Group:		Applications/Editors/Vim
Requires:	%{name} >= 0.23.0
Requires:	file
Requires:	vim-rt
Suggests:	highlight
Suggests:	the_silver_searcher
%if "%{_rpmversion}" >= "4.6"
BuildArch:	noarch
%endif

%description -n vim-plugin-fzf
fzf integration for Vim.

%package -n vim-plugin-fzf-doc
Summary:	Documentation for fzf Vim plugin
Group:		Applications/Editors/Vim
Requires:	vim-plugin-fzf = %{version}-%{release}
Requires:	vim-rt
%if "%{_rpmversion}" >= "4.6"
BuildArch:	noarch
%endif

%description -n vim-plugin-fzf-doc
Documentation for fzf Vim plugin.

%prep
%setup -q -b1 -a2
%{__mv} fzf.vim-%{fzfvimrev}* fzf.vim
%{__sed} -i -e "s@let s:bin_dir = .*@let s:bin_dir = '%{_datadir}/fzf/vim/bin/'@" fzf.vim/autoload/fzf/vim.vim
%{__sed} -i -e '1s,.*env bash,#!/bin/bash,' fzf.vim/bin/preview.sh
%{__sed} -i -e '1s,.*env perl,#!%{__perl},' fzf.vim/bin/tags.pl

%build
%{__make} FZF_VERSION=%{version} FZF_REVISION=%{fzfrev} GOFLAGS=-mod=vendor

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{%{_bindir},%{_datadir}/fzf/vim/bin,%{_mandir}/man1,%{bash_compdir},%{zsh_compdir}}
install -d $RPM_BUILD_ROOT%{_datadir}/vim/{doc,autoload,plugin/fzf}

cp -p target/fzf-linux* $RPM_BUILD_ROOT%{_bindir}/fzf
cp -p man/man1/fzf.1 $RPM_BUILD_ROOT%{_mandir}/man1
cp -p shell/completion.bash $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p shell/key-bindings.bash $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p shell/completion.zsh $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p shell/key-bindings.zsh $RPM_BUILD_ROOT%{_datadir}/fzf
cp -rp fzf.vim/autoload/fzf $RPM_BUILD_ROOT%{_datadir}/vim/autoload
cp -p plugin/fzf.vim $RPM_BUILD_ROOT%{_datadir}/vim/plugin/fzf.vim
cp -p fzf.vim/plugin/fzf.vim $RPM_BUILD_ROOT%{_datadir}/vim/plugin/fzf/fzf.vim
cp -p fzf.vim/doc/fzf-vim.txt $RPM_BUILD_ROOT%{_datadir}/vim/doc/fzf.txt
cp -p fzf.vim/bin/{preview.sh,tags.pl} $RPM_BUILD_ROOT%{_datadir}/fzf/vim/bin

%clean
rm -rf $RPM_BUILD_ROOT

%post -n vim-plugin-fzf-doc
%vim_doc_helptags

%postun -n vim-plugin-fzf-doc
%vim_doc_helptags

%files
%defattr(644,root,root,755)
%doc BUILD.md CHANGELOG.md README.md
%attr(755,root,root) %{_bindir}/fzf
%dir %{_datadir}/fzf
%{_mandir}/man1/fzf.1*

%files -n bash-completion-fzf
%defattr(644,root,root,755)
%{_datadir}/fzf/completion.bash
%{_datadir}/fzf/key-bindings.bash

%files -n zsh-completion-fzf
%defattr(644,root,root,755)
%{_datadir}/fzf/completion.zsh
%{_datadir}/fzf/key-bindings.zsh

%files -n vim-plugin-fzf
%defattr(644,root,root,755)
%doc README-VIM.md fzf.vim/README.md
%dir %{_datadir}/fzf/vim
%dir %{_datadir}/fzf/vim/bin
%attr(755,root,root) %{_datadir}/fzf/vim/bin/preview.sh
%attr(755,root,root) %{_datadir}/fzf/vim/bin/tags.pl
%{_datadir}/vim/autoload/fzf
%{_datadir}/vim/plugin/fzf.vim
%{_datadir}/vim/plugin/fzf

%files -n vim-plugin-fzf-doc
%defattr(644,root,root,755)
%{_datadir}/vim/doc/fzf.txt
%changelog
* Wed Dec 09 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/fzf.git;a=log;h=master

* Tue Dec 08 2020 Jan Palus <atler@pld-linux.org> 44d4685
- up to 0.24.4

* Sun Nov 08 2020 Jan Palus <atler@pld-linux.org> fc3e919
- up to 0.24.2

* Sun Nov 08 2020 Jan Palus <atler@pld-linux.org> 468eb16
- add feature rich vim plugin extension by same author

* Wed Oct 28 2020 Jan Palus <atler@pld-linux.org> 80124c6
- up to 0.24.1

* Tue Oct 27 2020 Jan Palus <atler@pld-linux.org> 284188b
- up to 0.24.0

* Sun Oct 11 2020 Jan Palus <atler@pld-linux.org> ffe54de
- up to 0.23.1

* Fri Oct 09 2020 Jan Palus <atler@pld-linux.org> 38ff0c7
- typo

* Fri Oct 09 2020 Jan Palus <atler@pld-linux.org> 2f6bb97
- updated supported arch list (32bit x86 dropped by upstream); rel 2

* Thu Oct 08 2020 Jan Palus <atler@pld-linux.org> 635ce84
- up to 0.23.0

* Sun Aug 02 2020 Jan Palus <atler@pld-linux.org> 28e1380
- up to 0.22.0

* Tue Jul 28 2020 Jan Palus <atler@pld-linux.org> 27c72a2
- completion.* are not fzf command completions, they're meant to be sourced; rel 2

* Sat Jul 11 2020 Jan Palus <atler@pld-linux.org> da55bc6
- support same arch list as golang

* Sat Jul 11 2020 Jan Palus <atler@pld-linux.org> 92db876
- explicitly use vendor modules

* Sat Jul 11 2020 Jan Palus <atler@pld-linux.org> f5228bc
- fix source url

* Sat Jul 11 2020 Jan Palus <atler@pld-linux.org> 855f089
- new (version 0.21.1)

